/// <reference types="react" />
import { hasUsableData } from '@rest-hooks/core';
export { useCache, useFetcher, useRetrieve, useResource, useSubscription, useMeta, useError, useInvalidator, useResetter, useDenormalized, SimpleRecord, Entity as NestedEntity, isEntity, FlatEntity as Entity, schema as schemas, usePromisifiedDispatch, Endpoint, Index, } from '@rest-hooks/core';
export type { FetchShape, ReadShape, MutateShape, SetShapeParams, ParamsFromShape, AbstractInstanceType, FetchOptions, UpdateFunction, FetchAction, InvalidateAction, UnsubscribeAction, SubscribeAction, ResetAction, ReceiveAction, State, ReceiveTypes, PK, Dispatch, Middleware, MiddlewareAPI, ActionTypes, Manager, Schema, Normalize, NormalizeNullable, Denormalize, DenormalizeNullable, EndpointExtraOptions, FetchFunction, ResolveType, EndpointParam, InferReturn, EndpointInterface, ReadEndpoint, MutateEndpoint, IndexInterface, IndexParams, ArrayElement, NetworkError, } from '@rest-hooks/core';
export { Resource, SimpleResource } from './resource';
export type { SchemaDetail, SchemaList, Method } from './resource/types';
export { CacheProvider, ExternalCacheProvider, PromiseifyMiddleware, NetworkErrorBoundary, mapMiddleware, } from './react-integration';
export { PollingSubscription, DevToolsManager, SubscriptionManager, DefaultConnectionListener, } from './manager';
export type { ConnectionListener, DevToolsConfig } from './manager';
export { default as useSelectionUnstable } from './react-integration/hooks/useSelection';
export declare const __INTERNAL__: {
    initialState: Readonly<{
        entities: {
            readonly [entityKey: string]: {
                readonly [pk: string]: unknown;
            } | undefined;
        };
        indexes: import("@rest-hooks/normalizr").NormalizedIndex;
        results: {
            readonly [key: string]: unknown;
        };
        meta: {
            readonly [key: string]: {
                readonly date: number;
                readonly error?: import("@rest-hooks/core").NetworkError | import("@rest-hooks/core").UnknownError | undefined;
                readonly expiresAt: number;
                readonly prevExpiresAt?: number | undefined;
                readonly invalidated?: boolean | undefined;
            };
        };
        entityMeta: {
            readonly [entityKey: string]: {
                readonly [pk: string]: {
                    readonly date: number;
                    readonly expiresAt: number;
                };
            };
        };
        optimistic: import("@rest-hooks/core").ReceiveAction<string | number | object | null, any>[];
    }>;
    StateContext: import("react").Context<Readonly<{
        entities: {
            readonly [entityKey: string]: {
                readonly [pk: string]: unknown;
            } | undefined;
        };
        indexes: import("@rest-hooks/normalizr").NormalizedIndex;
        results: {
            readonly [key: string]: unknown;
        };
        meta: {
            readonly [key: string]: {
                readonly date: number;
                readonly error?: import("@rest-hooks/core").NetworkError | import("@rest-hooks/core").UnknownError | undefined;
                readonly expiresAt: number;
                readonly prevExpiresAt?: number | undefined;
                readonly invalidated?: boolean | undefined;
            };
        };
        entityMeta: {
            readonly [entityKey: string]: {
                readonly [pk: string]: {
                    readonly date: number;
                    readonly expiresAt: number;
                };
            };
        };
        optimistic: import("@rest-hooks/core").ReceiveAction<string | number | object | null, any>[];
    }>>;
    DispatchContext: import("react").Context<(value: import("@rest-hooks/core").ActionTypes) => Promise<void>>;
    RIC: (cb: (...args: any[]) => void, options: any) => void;
    hasUsableData: typeof hasUsableData;
    buildInferredResults: typeof import("@rest-hooks/core/lib/state/selectors/buildInferredResults").default;
};
//# sourceMappingURL=index.d.ts.map