import React from 'react';
import type { NetworkError } from '@rest-hooks/core';
interface Props<E extends NetworkError> {
    children: React.ReactNode;
    fallbackComponent: React.ComponentType<{
        error: E;
    }>;
}
interface State<E extends NetworkError> {
    error?: E;
}
export default class NetworkErrorBoundary<E extends NetworkError> extends React.Component<Props<E>, State<E>> {
    static defaultProps: {
        fallbackComponent: ({ error }: {
            error: NetworkError;
        }) => JSX.Element;
    };
    static getDerivedStateFromError(error: NetworkError | any): {
        error: NetworkError;
    } | undefined;
    state: State<E>;
    render(): React.ReactNode;
}
export {};
//# sourceMappingURL=NetworkErrorBoundary.d.ts.map